/*
 *	timer.c
 */

#include "dinv.h"

vu32	ClockTick;

extern void IRQHandler();

/*
 *	InitTimer
 */
void InitTimer()
{
	/*
	 *	Initialize timer unit
	 */
	WRITE_REG16(TMR_CNT0, (u16)TIMER_COUNTER);
	WRITE_REG16(TMR_CTL0, TMR_ENABLE | TMR_INTREN | TMR_64CLOCK);

	ClockTick = 0;

	/*
	 *	Enable interrupt
	 */
	WRITE_REG32(INT_VECTOR, (vu32)IRQHandler);
	WRITE_REG16(INT_IE, INT_TMR0);
	WRITE_REG16(INT_IME, INT_IME_ON);
}

/*
 *	Wait
 */
void Wait(u32 msec)
{
	msec += ClockTick;
	while (ClockTick < msec)
		;
}

/*
 *	KeyWait
 */
u16 KeyWait(u16 keyptn, u32 msec)
{
	u16		key = 0;

	msec += ClockTick;
	while (ClockTick < msec) {
		if ((key = GetKey()) & keyptn)
			break;
	}

	return key;
}

